# Lua Exercises

This repo contains some Lua exercises along with automated tests for
solutions.  Each file contains a description of the problem and an
area for a solution as well as the tests.

## Set Up

To get started, create a fork of this repo on your own account, then
clone it, passing the `--recursive` flag.  If you already cloned it
without passing `--recursive`, you can run `git submodule update
--init` to fix it.

```sh
git clone --recursive git@git.wip.sh:<your-username>/lua-exercises.git
# or
git clone git@git.wip.sh:<your-username>/lua-exercises.git
git submodule update --init
```

## Doing the Exercises

It's recommended that you roughly stick to the defined order of the
exercises, but feel free to deviate if you wish.  Some of the
exercises are relatively easy, whereas some of them (especially the
last few) are quite challenging; do not be disheartened if solving a
particular exercise takes you a long time, and feel free to ask for
help in the Discord server if you feel you are stuck.

You can define as many functions and constants as you need in the
solution area.  You might find it useful to temporarily comment out
some of the tests to work through the cases one by one (especially on
the more complex exercises), but do not modify the test code other
than this, and make sure all the cases are un-commented again before
considering the exercise solved.

To run the tests and check your solution for a given exercise, simply
run `lua <the-file>`.  For example, if you were working on the
anagrams exercise, you would run `lua 08_anagrams.lua`.  For each
exercise, the tests should run in well under a tenth of a second; if
it takes longer than this you should try to speed up your solution.
